# FMDRUM Parameters
FM_DRUM_PARAMS = {
    "page_1": {
        "tune": {
            "cc_msb": 40,
            "nrpn_lsb": "1",
            "nrpn_msb": 73,
            "max_val": 60,
            "min_val": -60,
            "default": 0,
        },
        "stim": {"cc_msb": 41, "nrpn_lsb": "1", "nrpn_msb": 74},
        "sdep": {"cc_msb": 42, "nrpn_lsb": "1", "nrpn_msb": 75},
        "algo": {
            "cc_msb": 43,
            "nrpn_lsb": "1",
            "nrpn_msb": 76,
            "max_midi": 6,
            "max_val": 7,
            "min_val": 1,
            "default": 1,
        },
        "OP.C": {"cc_msb": 44, "nrpn_lsb": "1", "nrpn_msb": 77},
        "OP.AB": {"cc_msb": 45, "nrpn_lsb": "1", "nrpn_msb": 78},
        "FDBK": {"cc_msb": 46, "nrpn_lsb": "1", "nrpn_msb": 79},
        "FOLD": {"cc_msb": 47, "nrpn_lsb": "1", "nrpn_msb": 80},
    },
    "page_2": {
        "RATIO1": {
            "cc_msb": 48,
            "nrpn_lsb": "1",
            "nrpn_msb": 81,
            "max_val": 31.75,
            "min_val": 0.001,
            "default": 0.500,
        },
        "DEC1": {"cc_msb": 49, "nrpn_lsb": "1", "nrpn_msb": 82},
        "END1": {"cc_msb": 50, "nrpn_lsb": "1", "nrpn_msb": 83},
        "MOD1": {"cc_msb": 51, "nrpn_lsb": "1", "nrpn_msb": 84},
        "RATIO2": {
            "cc_msb": 52,
            "nrpn_lsb": "1",
            "nrpn_msb": 85,
            "max_val": 31.75,
            "min_val": 0.001,
            "default": 0.500,
        },
        "DEC2": {"cc_msb": 53, "nrpn_lsb": "1", "nrpn_msb": 86},
        "END2": {"cc_msb": 54, "nrpn_lsb": "1", "nrpn_msb": 87},
        "MOD2": {"cc_msb": 55, "nrpn_lsb": "1", "nrpn_msb": 88},
    },
    "page_3": {
        "HOLD": {"cc_msb": 56, "nrpn_lsb": "1", "nrpn_msb": 89},
        "DEC": {"cc_msb": 57, "nrpn_lsb": "1", "nrpn_msb": 90},
        "PH.C": {
            "cc_msb": 58,
            "nrpn_lsb": "1",
            "nrpn_msb": 91,
            "max_midi": 91,
            "max_val": 91,
        },
        "LEV": {"cc_msb": 59, "nrpn_lsb": "1", "nrpn_msb": 92},
        "NRST": {
            "cc_msb": 62,
            "nrpn_lsb": "1",
            "nrpn_msb": 95,
            "max_midi": 1,
            "max_val": 1,
        },
        "NRM": {
            "cc_msb": 63,
            "nrpn_lsb": "1",
            "nrpn_msb": 96,
            "max_midi": 1,
            "max_val": 1,
        },
    },
    "page_4": {
        "NHLD": {"cc_msb": 70, "nrpn_lsb": "1", "nrpn_msb": 97},
        "NDEC": {"cc_msb": 71, "nrpn_lsb": "1", "nrpn_msb": 98},
        "TRAN": {
            "cc_msb": 72,
            "nrpn_lsb": "1",
            "nrpn_msb": 99,
            "max_midi": 124,
            "max_val": 124,
        },
        "TLEV": {"cc_msb": 73, "nrpn_lsb": "1", "nrpn_msb": 100},
        "BASE": {"cc_msb": 74, "nrpn_lsb": "1", "nrpn_msb": 101},
        "WDTH": {"cc_msb": 75, "nrpn_lsb": "1", "nrpn_msb": 102},
        "GRAN": {"cc_msb": 76, "nrpn_lsb": "1", "nrpn_msb": 103},
        "NLEV": {"cc_msb": 77, "nrpn_lsb": "1", "nrpn_msb": 104},
    },
}
