FM_TONE_PARAMS = {
    "page_1": {
        "ALGO": {
            "cc_msb": 40,
            "nrpn_lsb": "1",
            "nrpn_msb": 73,
            "max_midi": 7,
            "min_midi": 0,
            "max_val": 8,
            "min_val": 1,
            "default": 1,
        },
        "C": {
            "cc_msb": 41,
            "nrpn_lsb": "1",
            "nrpn_msb": 74,
            "max_midi": 18,
            "min_midi": 0,
            "max_val": 16,
            "min_val": 0.25,
            "default": 1.00,
        },
        "A": {
            "cc_msb": 42,
            "nrpn_lsb": "1",
            "nrpn_msb": 75,
            "max_midi": 35,
            "min_midi": 0,
            "max_val": 16,
            "min_val": 0.25,
            "default": 1.00,
        },
        "B": {
            "cc_msb": 43,
            "nrpn_lsb": "1",
            "nrpn_msb": 76,
            "max_midi": 3,
            "min_midi": 0,
            "max_val": [16, 16],
            "min_val": [0.25, 0.25],
            "default": [1.00, 1.00],
        },
        "HARM": {
            "cc_msb": 44,
            "nrpn_lsb": "1",
            "nrpn_msb": 77,
            "max_midi": 37,
            "min_midi": 90,
            "max_val": 26,
            "min_val": -26,
            "default": 0.00,
        },
        "DTUN": {
            "cc_msb": 45,
            "nrpn_lsb": "1",
            "nrpn_msb": 78,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "FDBK": {
            "cc_msb": 46,
            "nrpn_lsb": "1",
            "nrpn_msb": 79,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "MIX": {
            "cc_msb": 47,
            "nrpn_lsb": "1",
            "nrpn_msb": 80,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 63,
            "min_val": -63,
            "default": -63,
        },
    },
    "page_2": {
        "A": {
            "atk": {
                "cc_msb": 48,
                "nrpn_lsb": "1",
                "nrpn_msb": 81,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
            "dec": {
                "cc_msb": 49,
                "nrpn_lsb": "1",
                "nrpn_msb": 82,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 32,
            },
            "end": {
                "cc_msb": 50,
                "nrpn_lsb": "1",
                "nrpn_msb": 83,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 127,
            },
            "lev": {
                "cc_msb": 51,
                "nrpn_lsb": "1",
                "nrpn_msb": 84,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
        },
        "B": {
            "atk": {
                "cc_msb": 48,
                "nrpn_lsb": "1",
                "nrpn_msb": 81,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
            "dec": {
                "cc_msb": 49,
                "nrpn_lsb": "1",
                "nrpn_msb": 82,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 32,
            },
            "end": {
                "cc_msb": 50,
                "nrpn_lsb": "1",
                "nrpn_msb": 83,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 127,
            },
            "lev": {
                "cc_msb": 51,
                "nrpn_lsb": "1",
                "nrpn_msb": 84,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
        },
    },
    "page_3": {
        "ADEL": {
            "cc_msb": 56,
            "nrpn_lsb": "1",
            "nrpn_msb": 89,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "ATRG": {
            "cc_msb": 57,
            "nrpn_lsb": "1",
            "nrpn_msb": 90,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "default": 1,
        },
        "ARST": {
            "cc_msb": 58,
            "nrpn_lsb": "1",
            "nrpn_msb": 91,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "default": 1,
        },
        "PHRT": {
            "cc_msb": 59,
            "nrpn_lsb": "1",
            "nrpn_msb": 92,
            "max_midi": 4,
            "min_midi": 0,
            "options": ["off", "all", "c", "a+b", "a+b2"],
            "default": "all",
        },
        "BDEL": {
            "cc_msb": 60,
            "nrpn_lsb": "1",
            "nrpn_msb": 93,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "BTRG": {
            "cc_msb": 61,
            "nrpn_lsb": "1",
            "nrpn_msb": 94,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "default": 1,
        },
        "BRST": {
            "cc_msb": 62,
            "nrpn_lsb": "1",
            "nrpn_msb": 95,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "default": 1,
        },
    },
    "page_4": {
        "Ratio_Offset": {
            "C": {
                "cc_msb": 70,
                "nrpn_lsb": "1",
                "nrpn_msb": 97,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 0.999,
                "min_val": -1.00,
                "default": 0.00,
            },
            "A": {
                "cc_msb": 71,
                "nrpn_lsb": "1",
                "nrpn_msb": 98,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 0.999,
                "min_val": -1.00,
                "default": 0.00,
            },
            "B1": {
                "cc_msb": 72,
                "nrpn_lsb": "1",
                "nrpn_msb": 99,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 0.999,
                "min_val": -1.00,
                "default": 0.00,
            },
            "B2": {
                "cc_msb": 73,
                "nrpn_lsb": "1",
                "nrpn_msb": 100,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 0.999,
                "min_val": -1.00,
                "default": 0.00,
            },
        },
        "Key_Track": {
            "A": {
                "cc_msb": 75,
                "nrpn_lsb": "1",
                "nrpn_msb": 102,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
            "B1": {
                "cc_msb": 76,
                "nrpn_lsb": "1",
                "nrpn_msb": 103,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
            "B2": {
                "cc_msb": 77,
                "nrpn_lsb": "1",
                "nrpn_msb": 104,
                "max_midi": 127,
                "min_midi": 0,
                "max_val": 127,
                "min_val": 0,
                "default": 0,
            },
        },
    },
}
