WAVETONE_PARAMS = {
    "page_1": {
        "TUN1": {
            "cc_msb": 40,
            "nrpn_lsb": "1",
            "nrpn_msb": 73,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 5,
            "min_val": -5,
            "default": 0,
        },
        "WAV1": {
            "cc_msb": 41,
            "nrpn_lsb": "1",
            "nrpn_msb": 74,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 120,
            "min_val": 0,
            "default": 0,
        },
        "PD1": {
            "cc_msb": 42,
            "nrpn_lsb": "1",
            "nrpn_msb": 75,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 100,
            "min_val": 0,
            "default": 50,
        },
        "LEV1": {
            "cc_msb": 43,
            "nrpn_lsb": "1",
            "nrpn_msb": 76,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 100,
        },
        "TUN2": {
            "cc_msb": 44,
            "nrpn_lsb": "1",
            "nrpn_msb": 77,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 5,
            "min_val": -5,
            "default": 0,
        },
        "WAV2": {
            "cc_msb": 45,
            "nrpn_lsb": "1",
            "nrpn_msb": 78,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 120,
            "min_val": 0,
            "default": 0,
        },
        "PD2": {
            "cc_msb": 46,
            "nrpn_lsb": "1",
            "nrpn_msb": 79,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 100,
            "min_val": 0,
            "default": 50,
        },
        "LEV2": {
            "cc_msb": 47,
            "nrpn_lsb": "1",
            "nrpn_msb": 80,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 100,
        },
    },
    "page_2": {
        "OFS1": {
            "cc_msb": 48,
            "nrpn_lsb": "1",
            "nrpn_msb": 81,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 10,
            "min_val": -10,
            "default": 0,
        },
        "TBL1": {
            "cc_msb": 49,
            "nrpn_lsb": "1",
            "nrpn_msb": 82,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "options": ["prim", "harm"],
            "default": "prim",
        },
        "MOD": {
            "cc_msb": 50,
            "nrpn_lsb": "1",
            "nrpn_msb": 83,
            "max_midi": 3,
            "min_midi": 0,
            "max_val": 3,
            "min_val": 0,
            "options": ["off", "ring mod", "ring mod fixed", "hard sync"],
            "default": "off",
        },
        "RSET": {
            "cc_msb": 51,
            "nrpn_lsb": "1",
            "nrpn_msb": 84,
            "max_midi": 2,
            "min_midi": 0,
            "max_val": 2,
            "min_val": 0,
            "options": ["off", "on", "random"],
            "default": "on",
        },
        "OFS2": {
            "cc_msb": 52,
            "nrpn_lsb": "1",
            "nrpn_msb": 85,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 10,
            "min_val": -10,
            "default": 0,
        },
        "TBL2": {
            "cc_msb": 53,
            "nrpn_lsb": "1",
            "nrpn_msb": 86,
            "max_midi": 1,
            "min_midi": 0,
            "max_val": 1,
            "min_val": 0,
            "options": ["prim", "harm"],
            "default": "prim",
        },
        "DRIF": {
            "cc_msb": 55,
            "nrpn_lsb": "1",
            "nrpn_msb": 88,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
    },
    "page_3": {
        "ATK": {
            "cc_msb": 56,
            "nrpn_lsb": "1",
            "nrpn_msb": 89,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "HOLD": {
            "cc_msb": 57,
            "nrpn_lsb": "1",
            "nrpn_msb": 90,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 127,
        },
        "DEC": {
            "cc_msb": 58,
            "nrpn_lsb": "1",
            "nrpn_msb": 91,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 127,
        },
        "NLEV": {
            "cc_msb": 59,
            "nrpn_lsb": "1",
            "nrpn_msb": 92,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "BASE": {
            "cc_msb": 60,
            "nrpn_lsb": "1",
            "nrpn_msb": 93,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
        "WDTH": {
            "cc_msb": 61,
            "nrpn_lsb": "1",
            "nrpn_msb": 94,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 127,
        },
        "TYPE": {
            "cc_msb": 62,
            "nrpn_lsb": "1",
            "nrpn_msb": 95,
            "max_midi": 2,
            "min_midi": 0,
            "max_val": 2,
            "min_val": 0,
            "options": ["grain nose", "tuned noise", "sample and hold noise"],
            "default": 0,
        },
        "CHAR": {
            "cc_msb": 63,
            "nrpn_lsb": "1",
            "nrpn_msb": 96,
            "max_midi": 127,
            "min_midi": 0,
            "max_val": 127,
            "min_val": 0,
            "default": 0,
        },
    },
}
